import { encode_script } from '@scrow/tapscript/script';
import { encode_witness } from './witness.js';
import { decode_tx, encode_tx } from '@scrow/tapscript/tx';
import PSBTSchema from '../schema.js';
export function create_psbt(txhex) {
    const global = [], inputs = [];
    const txdata = decode_tx(txhex);
    const txbase = encode_tx(txdata, true).hex;
    for (const txin of txdata.vin) {
        const input = [];
        if (typeof txin.scriptSig !== 'number' && txin.scriptSig.length > 0) {
            const script_sig = encode_script(txin.scriptSig, true).hex;
            input.push({ label: 'FINAL_SCRIPTSIG', value: script_sig });
        }
        if (txin.witness.length > 0) {
            const witness = encode_witness(txin.witness);
            input.push({ label: 'FINAL_SCRIPTWITNESS', value: witness });
        }
        inputs.push(input);
    }
    global.push({ label: 'UNSIGNED_TX', value: txbase });
    return PSBTSchema.data.parse({ global, inputs, outputs: [] });
}
