import { assert } from '../util/index.js';
export function get_key_type(keymap, label) {
    const ent = Object.entries(keymap).find(e => e[1] === label);
    assert.exists(ent, 'type does not exist for label: ' + label);
    return Number(ent[0]);
}
export function has_global_key(globals, label) {
    return has_keypair(globals, label);
}
export function get_global_key(globals, label) {
    return get_keypair(globals, label);
}
export function has_input_key(input, label) {
    return has_keypair(input, label);
}
export function get_input_key(input, label) {
    return get_keypair(input, label);
}
export function has_output_key(output, label) {
    return has_keypair(output, label);
}
export function get_output_key(output, label) {
    return get_keypair(output, label);
}
function has_keypair(keys, label) {
    const kp = keys.find(e => e.label === label);
    return kp !== undefined;
}
function get_keypair(keys, label) {
    const kp = keys.find(e => e.label === label);
    assert.exists(kp, 'keypair not found: ' + label);
    return kp;
}
