import { Buff } from '@cmdcode/buff';
import { decode_tx } from '@scrow/tapscript/tx';
import { get_global_key, has_global_key } from './keypair.js';
export function get_io_counts(global) {
    const version = (has_global_key(global, 'VERSION'))
        ? Number(get_global_key(global, 'VERSION'))
        : 0;
    if (version === 2) {
        const vin_kp = get_global_key(global, 'INPUT_COUNT');
        const out_kp = get_global_key(global, 'OUTPUT_COUNT');
        const vin_ct = Buff.bytes(vin_kp.value).num;
        const out_ct = Buff.bytes(out_kp.value).num;
        return [vin_ct, out_ct];
    }
    else {
        const keypair = get_global_key(global, 'UNSIGNED_TX');
        const txdata = decode_tx(keypair.value, false);
        const vin_ct = txdata.vin.length;
        const out_ct = txdata.vout.length;
        return [vin_ct, out_ct];
    }
}
